--=============================================================================
-- File:	CHH_Common.lua
-- Author:	rudy
-- Description:	Config, Common functions
--=============================================================================

function CHH_GetVari( object, index )

  while ( object ) do
    if ( object[index] ~= nil ) then
      return( object[index] );
    end

    object = object:GetParent();
  end

  return( nil );

end

function CHH_SetConfigOption( option, frame )

  if ( not frame ) then
    frame = this;
  end

  frame.ch_config_option = option;

end

function CHH_OptionCheckBoxClicked( option )

  CH_ConfigSetOption( option, CH_ToBoolean(this:GetChecked()) );

end

function CHH_OptionCheckBoxInit( option )

  this:SetChecked( CH_Config[option] );

end

function CHH_OptionSliderClicked( option, msg )

  local rt = this:GetValue();

  getglobal(this:GetName().."Text"):SetText( string.format(msg,rt) );
  CH_ConfigSetOption( option, tonumber(rt) );

end

function CHH_OptionSliderInit( option )

  this:SetValue( CH_Config[option] );

end

function CHH_OptionSliderLoad( min, max, step, minTxt, highTxt )

  getglobal(this:GetName().."High"):SetText(highTxt);
  getglobal(this:GetName().."Low"):SetText(minTxt);
  this:SetMinMaxValues(min,max);
  this:SetValueStep(step);

end

function CHH_HintOptionSliderLoad( option, min, max, step, minTxt, highTxt, title )

  CHH_SetConfigOption( option );
  this.ch_slider_title = title;

  getglobal(this:GetName().."High"):SetText(highTxt);
  getglobal(this:GetName().."Low"):SetText(minTxt);
  this:SetMinMaxValues(min,max);
  this:SetValueStep(step);

end

function CHH_DropdownSetLabel( spellName, frame, noneIdx, noneLabel )

  if ( spellName == noneIdx ) then
    UIDropDownMenu_SetText( noneLabel, frame );
  else
    UIDropDownMenu_SetText( spellName, frame );
  end

end
